(* PCIADA > VMEMM > VMEADA > CC32 *)

USES   crt,DOS,_hexnum,_pcivme;

var    vmeadr,dataw,datar                   : longint;
       i                                    : longint;
       N : 0..31;
       A : 0..15;
       F : 0..31;
       NAF : word;
const  pciada_nr = 0;

(* *************************************** *)
  procedure wr32(segm,offs:word; d32:longint); far; external;
  procedure rd32(segm,offs:word; var v:longint); far; external;
  {$L _RW32.OBJ}


begin
  n:=0;
  a:=0;
  f:=0;             

  clrscr;
  PCIADA_suchen(pciada_nr);    (* PCIADA-Karte suchen *)
  PCIADA_tst(pciada_nr);
  VMEMM_test;                  (* test VME-Power u. Kabel*)
  VMEMM_init;                  (* PCIADA-on + VME-Reset + SYSFAIL-Reset*)

  wr_ispl_stat;          
  wr_ispl_irq;                    
  wr_plx_int_reg;             
  dataw      := $1234;
  datar      := 0;
  vmeadr     := $550000;
{
  VME_WR(0,vmeadr+$C,$39,d16);    (* read VMEADA - Status *)
  VME_RD(datar,vmeadr+$C,$39,d16);    (* read VMEADA - Status *)
  writeln('VMEADA-Status   ',num2bin(datar,4));
  VME_RD(datar,vmeadr,$39,d16);
  writeln('CC32-Status     ',num2bin(datar,4));

  writeln('test cc32 Statusregister');
  for dataw := 0 to $1fff do
  begin
  delay(0);
  VME_WR(dataw,vmeadr+$C,$39,d16);    (* read VMEADA - Status *)
  VME_RD(datar,vmeadr+$C,$39,d16);    (* read VMEADA - Status *)
  if dataw <> (datar and $1fff) then writeln('error');
  end;

  delay(2000);

  NAF:= 27 shl 10 + 0 shl 6 + 0 shl 2;
  VME_wr(0,vmeadr+NAF,$39,d32);         (*  set inhibit *)

  NAF:= 0 shl 10 + 2 shl 6 + 0 shl 2;
  VME_wr(0,vmeadr+NAF,$39,d32);        (* camac C + Inhibit reset *)
}
  n:=1; a:=0; f:=5;
  NAF:= N shl 10 + A shl 6 + F shl 2;     
  VME_WR($1000,vmeadr+$C,$39,d16);    (* AutoRead= $1000 *)
  VME_WR(0,vmeadr+NAF,$39,d16);   (* clear testmodul *)
  VME_WR(0,vmeadr+NAF,$39,d16);   (* clear testmodul *)

repeat

  for i := 0 to $ffffff do
  begin
    VME_rd(datar,vmeadr+NAF,$39,d32);        (* reset cc32 *)
    if i <> (datar and $00ffffff) then
    begin writeln(i,'   ', datar and $00fffff);
      delay(1000);
    end;
  end;
  write('*');
until keypressed;
end.
