{arw JUL 2002 / this program runs with PCIADA in higher or lower memory
 using only the function from _unreal.pas}


USES   crt,DOS,_hexnum,_pcic32x,_unreal;

var    vmeadr,dataw,datar,datahw,datalw,datax : longint;
       NAF,i,j                                : integer;
       errorflag                               : boolean;
const  pciada_nr  = 0;             
                                     
var  n               : 0..31;
     a               : 0..16;
     f               : 0..31 ;
var  data            : LongInt;
var  q,x,s,cs        : integer;
     ch              : char;

const nmax           = 24;        (* 24 = Camac-Crate mit 25 Stationen *)
      version        = 'CC32X-Ver. 1.2';



(* VAR IOBASE, CC32BASE def. by UNIT _pcicc32 *)
(* *************************************** *)

Procedure test_led1;
begin
  writeln('test optical N,A,F and DATA LEDs ) *** end loop with press any key');
  repeat

    cc32_wr24(23,15,7,$ffffff);
    delay(300);
    cc32_wr24(1,0,8,$000000);
    delay(300);
    cc32_wr24(24,15,7,$ffffff);
    delay(300);
    cc32_wr24(2,0,8,$000000);
    delay(300);
  until keypressed;
  ch := ReadKey;
end;
Procedure test_led2;       
begin;
  writeln('test optical all LEDs *** end loop with press any key');
  repeat
    data := 1;
    repeat
      cc32_wr24(1,0,0,data);
      data := data * 2;
      delay(1);
    until data = $1000000;
    cc32_wr24(1,1,1,data); delay(20);
    cc32_wr24(2,2,2,data); delay(20);
    cc32_wr24(4,4,4,data); delay(20);
    cc32_wr24(8,8,8,data); delay(20);
    cc32_wr24(16,0,0,data);delay(20);
    cc32_wr24(nmax,0,0,data); (* Q X *)
    delay(1);
    cc32_Z;
    delay(5);
    cc32_C;
    delay(5);
    cc32_set_I;
    delay(5);
    cc32_res_I;
    cc32_set_LMbit(nmax);       (* set LMASK24 *)
    cc32_wr24(nmax,0,0,5);      (* aktiviere LAM24 *)
    delay(1);
    cc32_res_LAMff;
  until keypressed;
  ch := ReadKey;
end;
procedure test_naf;
  begin
  writeln('test NAF-Signale mit N = 1*** end loop with press any key');
  repeat
    for a:= 0 to 15 do
    begin
      cc32_wr24(2,a,0,$ffffff);
      cc32_rd16(1,0,0,data);
      writeln(num2bin(data,4));
      delay(300);
    end;
    for f:= 0 to 15 do
    begin
      cc32_wr24(2,0,f,$ffffff);
      cc32_rd16(1,0,0,data);
      writeln(num2bin(data,4));
      delay(300);
    end;
  until keypressed;
  ch := ReadKey;
end;


procedure test_jumper;
begin
  clrscr;
  repeat
  cc32_wr16(31,0,0,datar);
  cc32_wr16(2,0,0,datar); (* reset Q,X *)
  cc32_rd16(0,0,0,datar);
  write('CC32 Status = ',num2hex(datar,4),' bin =',num2bin(datar,4));
  delay(1000);
  if (datar and $f0f0) <> $8010 then writeln(' set CC32-Modul-Number to 1');
  until datar and $f0f0 = $8010;
  writeln;
end;

Procedure test_broadcast;      
  begin
  errorflag := false;
  writeln('test broadcast-registers ************************ wait');
  n:=26; a:=0; f:=0;
  naf:= N shl 10 + A shl 6 + F shl 2;
  for dataw := 0 to $00ffffff do
  begin                
    wrx32(CC32BASE+naf,dataw);
    datar := rdx32(CC32BASE+naf);
    if (dataw) <> (datar) then
    begin
       writeln(' dataw  ',num2bin(dataw,8));
       writeln(' datar  ',num2bin(datar,8));
       writeln;
       errorflag := true;
    end;
  end;
  cc32_res;                                            
  datar := rdx32(CC32BASE+naf);
  if datar <> 0 then                
  begin
    writeln(' datar  ',num2bin(datar,8));
    errorflag := true;
  end;
end;
  procedure test_lammask;
  begin
  writeln('test lammask-registers ***************************** wait' );
  n:=28; a:=1; f:=0;
  NAF:= N shl 10 + A shl 6 + F shl 2;
  for dataw := 0 to $00ffffff do
  begin
    wrx32(CC32BASE+naf,dataw);
    datar := rdx32(CC32BASE+naf);
    datar := datar and $00ffffff;
    if (dataw) <> (datar) then
    begin
       writeln(' dataw  ',num2bin(dataw,8));
       writeln(' datar  ',num2bin(datar,8));
       writeln;
       errorflag := true;
       delay(1000);
    end;
  end;
  cc32_rd16(28,0,0,datar);
  if datar > 0 then
  begin
    writeln('lam-ff/status error');
    writeln(num2bin(datar,4));
    repeat until keypressed;ch := ReadKey;
  end;
  cc32_res;
  datar := rdx32(CC32BASE+naf);
  if datar <> 0 then
  begin
    writeln(' datar  ',num2bin(datar,8));
    errorflag := true;
  end;
end;

procedure test_cycletun;
begin
  writeln('test cyletun-registers ****************************** wait');
  for j:= 0 to 50 do
  begin
  write('*');
    for i := 0 to 2 do
    begin
      for dataw := 0 to $0000ffff do
      begin
        cc32_wr16(30,i,0,dataw);               (* write to station CC2 - 1 *)
        cc32_rd16(30,i,0,datar);
        if (dataw) <> (datar) then
        begin
          writeln;
          writeln(i,'   dataw  ',num2bin(dataw,8));
          writeln(i,'   datar  ',num2bin(datar,8));
          writeln;
          write(char(7)); delay(1000);
          errorflag := true;
        end;
      end;
    end;                     
  end;
  writeln;
end;
procedure test_cycletun_n1;
begin
  writeln('test cyletun on N1 ****************************** wait');
    cc32_res;
    cc32_rd16(30,i,0,datar);      
    if datar <> 0 then
    begin
      writeln(' datar  ',num2bin(datar,8));
      errorflag := true;
    end;
    cc32_wr16(30,0,0,$3);                (* set ct = 3 for N1 *)
    cc32_wr24(1,0,0,$1234);              (* Camac write To N1 *)
    naf:= 29 shl 10;
    datar := rdx32(CC32BASE+naf);  (* read all Led *)
    if datar <> $C3001234 then
    begin
      writeln(' datar  ',num2hex(datar,8));
      errorflag := true;                     
    end;
    if errorflag = true then
    begin
      Writeln('register error !!! press any key to next');
      repeat until keypressed;ch := ReadKey;
    end;
    cc32_wr16(30,0,0,0);                (* set ct = nomal for N1 *)
 end;                

procedure test_inhibit_ff;
var x : longint;
begin
  writeln('test inhibit-ff ****************************** wait');
  (* INHIBIT-BUS ist invers !!!!)
  cc32_wr16(27,1,0,0);               (* inhibit = reset *)
  for x := 0 to 2000000 do
  begin                             
    cc32_rd16(0,0,0,datar);
    datar := datar and $0002;
    if datar = 2 then writeln('inhibit-ff error !!!');
    cc32_rd16(27,0,0,datar);
    if datar <> 2 then writeln('inhibit-ff error !!!');
  end;
  cc32_wr16(27,0,0,0);               (* inhibit set *)
  for x := 0 to 2000000 do
  begin
    cc32_rd16(0,0,0,datar);
    datar := datar and $0002;
    if datar = 0 then writeln('inhibit-ff error !!!');
    cc32_rd16(27,0,0,datar);
    if datar <> 1 then writeln('inhibit-ff error !!!');
  end;
end;
procedure Test_Mask;
  var mask         : LongInt;
  var i,j          : integer;
begin
  writeln('test lam on dataway');
  cc32_res_lmall;
  n:=28; a:=4; f:=0;
  NAF:= N shl 10 + A shl 6 + F shl 2;
  datar := rdx32(CC32BASE+naf);
  if datar <> 0 then
  begin
    writeln('datar  ',num2bin(datar,8));
    writeln('N24*A4*F0 is not correct // Check LAM or Lam Status');
    writeln('press any key for lam-mask-test!');
    repeat
    until keypressed;
    ch := readkey;
  end
  else writeln('OK');
  writeln('test mask-register');

  for j := 1 to 3 do
  begin
    for i := 1 to nmax+1 do
    begin
      if j = 1 then cc32_res_lmall;
      if j < 3 then cc32_set_lmbit(i) else cc32_res_lmbit(i);
      cc32_rd_LAMmask(mask);
      writeln(' Mask ',num2bin(mask,6));
      cc32_wr24(1,0,0,mask);
      delay(200);
    end;
  end;
end;

procedure Test_Ndecode_Lam;
  var mask         : LongInt;
  var i,j,s        : integer;
begin
writeln('test N-decoder and Lam logic');
delay(1000);
repeat
  for n := 1 to nmax do
  begin
    cc32_res_LAMff;
    cc32_res_LMall;                          (* reset all LamMask *)
    cc32_set_LMbit(n);                      (* set LamMask Station 24 *)
    cc32_rd_LAMmask(data);
    datar := 1;
    if data <> (datar shl (n-1)) then writeln(n,' maskbit-error ');
    cc32_wr24qx(n,2,0,0);        (* set lam ff by n= 1  *)
    cc32_wr24qx(n,0,0,$5);       (* set lam ff by n= 24 *)
    cc32_wr24qx(n,0,0,data);     (* set lam ff + mask to wr-leds*)
    cc32_rd_LED(datar);
    if datar <> data then writeln(n,'led-error');
    delay(1);
    cc32_tst_LAMff;
    delay(1);
    cc32_res_LAMff;
    write(n);
    if cL = false then write(' /-N or L error');
    if cQ = true then  write(' /Q');
    if cX = true then  write(' /X');
    writeln;
    delay(100);
  end;
  until keypressed;
  ch := readkey;
end;

Procedure test_speed;
  var data,x       : longint;
begin
  writeln('test 10^6 write / read-led / increment / 24-bit');
  write(char(7));
  dataw := 0;
  n := 1; a := 1; f := 0;
  NAF:= N shl 10 + A shl 6 + F shl 2;
  repeat
    wrx32(CC32BASE+NAF,dataw);
    datar := rdx32(CC32BASE+NAF);
    datar := datar and $00fffff;
    dataw := dataw + 1;
  until dataw = 1000000;
  begin
  repeat
    writeln('test 10^7 camac-read 24 bit*** end loop with press any key' );
    write(char(7));
    x := 0;
{   cc32_wr16(30,0,0,$0003); }         (* set timing for N1 = min*)
    cc32_wr16(30,0,0,$0000);           (* set timing normal *)
    n := 1; a := 5; f := 0;
    NAF:= N shl 10 + A shl 6 + F shl 2;
    repeat
{   cc32_rd24(1,1,0,data);}
    datar := rdx32(CC32BASE+NAF);
    x := x+1;
    until x = 10000000;
 until keypressed;            
  ch := readkey;                
  end;
   begin
    writeln('test 10^7  camac-write 24 bit' );
    write(char(7));
    data := 0;
    repeat
    cc32_wr24(1,1,0,data);
    data := data+1;
    until data = 10000000;
  end;
  write(char(7));
End;


Procedure test_random;
  var wdata,rdata,i,error   : longint;
                   x   : word;
begin
  clrscr;
  write('test 10^6 write24, read24_led, compare');
  writeln('*** end loop with press any key' );

repeat
  i := 0;
  write(char(7));
  repeat              

    randomize;
    x := random($ffff);
    wdata := x;
    wdata := (wdata shl 8 + wdata) and $ffffff;
    cc32_wr24(1,0,0,wdata);
    cc32_rd_led(rdata);
                                     
    if wdata <> rdata then
    begin
      writeln('error');
      writeln('wdata ',num2bin(wdata,6));
      writeln('rdata ',num2bin(rdata,6));
      error := 1;
    delay(500);
    end;
    i := i+1;
  until i = 1000000;
  if error = 1 then
  begin
    writeln('error detected');
    error := 0;
  end
  until keypressed;
  ch := ReadKey;
End;

Procedure test_xqczil;
var      wdata,rdata,i  : longint;
         s              : integer;
begin
  repeat
    clrscr;
    cc32_C;                                   
    cc32_rd_LED(data);
    if cC = true  then writeln('             C    OK')
                  else writeln('  error      C');
    if cZ = true  then writeln('  error      Z');


    cc32_Z;
    cc32_rd_LED(data);
    if cZ = true then writeln('             Z    OK')
                 else writeln('  error      Z');
    if cC = true then writeln('  error      C');

    data := $0;
    cc32_wr24qx(nmax,0,0,data);               (* write to station CC2 - 1 *)
    if cX = true then writeln('             X    generiert')
                 else writeln('  !!!     no X    generiert');

    if cQ = true then writeln('             Q    generiert')
                 else writeln('  !!!     no Q    generiert');
    cc32_set_I;
    cc32_tst_I;
    if cI = true then writeln('             Inhibit on')
                 else writeln(' error       Inhibit off');
    cc32_res_I;
    cc32_tst_I;
    if cI = true then writeln(' error       Inhibit on')
                 else writeln('             Inhibit off');
    cc32_res_LAMff;
    cc32_set_lmbit(nmax);    (* enable lmaskbit *)
    cc32_wr16(24,0,0,5);     (* 200 ns puls cLAM *)
    cc32_tst_LAMff;
    if cL = true then writeln('             LAM-ff high')
                 else writeln('  error      LAM-ff low');
    cc32_rd16(28,0,0,datar);
    if datar <> 1 then writeln('  error      LAM-ff low');

    cc32_res_LAMff;
    cc32_tst_LAMff;
    if cL = true then writeln('  error      LAM-ff high')
                 else writeln('             LAM-ff low');
    writeln;
    writeln('press any key to quit from test X,Q,C,Z,I,L');
    delay(1000);
    until keypressed;
    ch := ReadKey;

End;

Procedure test_fcl1;
var      wdata,rdata,x      : longint;
         i,j,s            : integer;
begin
  clrscr;
  cc32_wr16(30,2,0,$0000);           (* set timing *)
  writeln('test fast-Camac-level1 *** end loop with press any key');
  repeat
  for i := 1 to 3000 do
  begin
     n := 24; a := 1; f := 5;
     naf:= n shl 10 + a shl 6 + f shl 2;
     cc32_wr16(nmax,1,0,$0003);               (* write to station CC2 - 1 *)
     n := nmax; a := 1; f := 5;
     naf:= n shl 10 + a shl 6 + f shl 2;
{    cc32_rd24qx(nmax,1,5,rdata);               (* write to station CC2 - 1 *)
     cc32_rd24qx(nmax,1,5,rdata);               (* write to station CC2 - 1 *)
     cc32_rd24qx(nmax,1,5,rdata);               (* write to station CC2 - 1 *)
     cc32_rd24qx(nmax,1,5,rdata);               (* write to station CC2 - 1 *)
}

       data := rdx32(CC32BASE+naf);  (* read24 *)
       if data and $80000000 = 0 then cQ := false else cQ := true;
       if data and $40000000 = 0 then cX := false else cX := true;
       datax:= data and $00ffffff;

       data := rdx32(CC32BASE+naf);  (* read24 *)
       if data and $80000000 = 0 then cQ := false else cQ := true;
       if data and $40000000 = 0 then cX := false else cX := true;
       datax:= data and $00ffffff;

       data := rdx32(CC32BASE+naf);  (* read24 *)
       if data and $80000000 = 0 then cQ := false else cQ := true;
       if data and $40000000 = 0 then cX := false else cX := true;
       datax:= data and $00ffffff;

       data := rdx32(CC32BASE+naf);  (* read24 *)
       if data and $80000000 = 0 then cQ := false else cQ := true;
       if data and $40000000 = 0 then cX := false else cX := true;
       datax:= data and $00ffffff;

       data :=  rdx32(CC32BASE+naf);  (* read24 *)
       if data and $80000000 = 0 then cQ := false else cQ := true;
       if data and $40000000 = 0 then cX := false else cX := true;
       datax:= data and $00ffffff;

       for s := 1 to 3000 do begin end;
   end

  until keypressed;
  ch := readkey;
end;


  procedure test_tm_register;
  begin
  writeln('test TestModul-Registers *** end loop with press any key');
  n:=1; a:=1; f:=0;
  NAF:= N shl 10 + A shl 6 + F shl 2;
  repeat
    for dataw := $0 to $00ffffff do
    begin
    wrx32(CC32BASE+naf,dataw);
    datar := rdx32(CC32BASE+naf);
    datar := datar and $00ffffff;
    if (dataw) <> (datar) then
    begin
       writeln(' dataw  ',num2bin(dataw,8));
       writeln(' datar  ',num2bin(datar,8));
       writeln;
       delay(100);
    end;
    end;
  until keypressed;
  ch := readkey;


end;

procedure read_counter;
  var x : longint;
begin
  writeln('read counter *** end loop with press any key');
  n := 1; a := 2; f := 0;
  naf:= n shl 10 + a shl 6 + f shl 2;
  wrx32(CC32BASE+naf,1);  (* clear counter *)
  repeat
    n := 1; a := 5; f := 0;
    naf:= n shl 10 + a shl 6 + f shl 2;
    wrx32(CC32BASE+naf,0);  (* clear counter *)
    for x := 0 to $ffffff do
    begin                         
      datar := rdx32(CC32BASE+naf);  (* read24 *)
      if x <> (datar and $00ffffff) then
      begin writeln(x,'   ', datar and $00ffffff);
        delay(1000);
      end;                          
      end;
    write('*');
  until keypressed;
  ch := readkey;
end;

procedure read_counter_fcl1_autoread;{################################}
  var x,dataold : longint;                                  
begin
  writeln('read counter fcl1+autoread *** end loop with press any key');
  cc32_wr16(1,4,0,0);          (* set Q-Mode *)
  cc32_wr16(30,0,0,$0);        (* set cycletune N1 = $3 *)
  cc32_wr24(28,1,0,$1000000);  (* set QLAM-MAsk *)
  n := 28; a := 1; f := 0;
  naf:= n shl 10 + a shl 6 + f shl 2;
  datar := rdx32(CC32BASE+naf);    (* read24 *)
  writeln(num2bin(datar,8));
  cc32_wr16(27,3,0,$0);        (* A=2>RDW on / A=3>RDW off *)
  cc32_rd16(27,0,0,datar);        
  writeln(datar);             
  repeat
    cc32_wr16(1,5,0,0);        (* clr counter *)
    pciada_autoread_on;
    n := 1; a := 0; f := 5;  (* fcl1 *)
    naf:= n shl 10 + a shl 6 + f shl 2;
    for x := 0 to $1ffff1 do
    begin
      datar := rdx32(CC32BASE+naf);  (* read24 *)
      datar := rdx32(CC32BASE+naf);  (* read24 *)
      datar := rdx32(CC32BASE+naf);  (* read24 *)
      datar := rdx32(CC32BASE+naf);  (* read24 *)
      datar := rdx32(CC32BASE+naf);  (* read24 *)
      datar := rdx32(CC32BASE+naf);  (* read24 *)
      datar := rdx32(CC32BASE+naf);  (* read24 *)
    end;
    PCIADA_autoread_off;
    if datar <> $C0DFFF9D then
    begin
      write('x = ',num2hex(x,8),'     ');
      writeln('error   ',num2hex(datar,8),'     ');
    end;
  write('*')
  until keypressed;
  ch := readkey;
  write(chr($7)); delay(3000);
end;
procedure read_counter_fcl1_autoread_rdw;{################################}
  var x,dataold : longint;                                  
begin
  writeln('read counter fcl1+autoread+rdw *** end loop with press any key');
  cc32_wr16(1,4,0,0);          (* set Q-Mode *)
  cc32_wr16(30,0,0,$0);        (* set cycletune N1 = $3 *)
  cc32_wr24(28,1,0,$1000000);  (* set QLAM-MAsk *)
  n := 28; a := 1; f := 0;
  naf:= n shl 10 + a shl 6 + f shl 2;
  datar := rdx32(CC32BASE+naf);    (* read24 *)
  writeln(num2bin(datar,8));
  cc32_wr16(27,2,0,dataw);     (* A=2>RDW on / A=3>RDW off *)
  cc32_rd16(27,0,0,datar);
  writeln(datar);
  repeat
    cc32_wr16(1,5,0,0);        (* clr counter *)
    pciada_autoread_on;
    n := 1; a := 0; f := 5;  (* fcl1 *)
    naf:= n shl 10 + a shl 6 + f shl 2;
    for x := 0 to $1ffff1 do
    begin
      datar := rdx32(CC32BASE+naf);  (* read24 *)
      datar := rdx32(CC32BASE+naf);  (* read24 *)
      datar := rdx32(CC32BASE+naf);  (* read24 *)
      datar := rdx32(CC32BASE+naf);  (* read24 *)
      datar := rdx32(CC32BASE+naf);  (* read24 *)
      datar := rdx32(CC32BASE+naf);  (* read24 *)
      datar := rdx32(CC32BASE+naf);  (* read24 *)
    end;
    PCIADA_autoread_off;
    if datar <> $ff3bff3a then
    begin
      write('x = ',num2hex(x,8),'     ');
      writeln('error   ',num2hex(datar,8),'     ');
    end;
  write('*');
  until keypressed;
  ch := readkey;
  write(chr($7)); delay(3000);
end;     
                            

(* YYYYYYYYYYYYYYYYYYYYYY          Hauptprogram          YYYYYYYYYYYYYYYYYYYYYYY*)
                            
begin
  clrscr;   
  PCICC32_tstandset(pciada_nr,version);(* PCIADA-Karte suchen *)
  PCIADA_init;                        (* definde intrrupt flanke *)
  cc32_res;
  clrscr;
  wr_ispl_stat;
  wr_plx_int_reg;
  write(chr($7)); delay(3000);
  clrscr;
  cc32_C;
  cc32_res;
  test_jumper;
  test_led1;
  test_led2;
  test_broadcast;
  test_lammask;
  test_cycletun;
  test_inhibit_ff;
  test_random;
  test_mask;
  test_xqczil;       
  test_fcl1;
  test_speed;
  writeln('have a CC32-Testmodul on Station N=1 for more tests?  (y,n)');
  repeat until keypressed; ch := readkey;
  ch := upcase(ch);
  if (ch = 'Y') or (ch = 'Z') then
  begin
    test_Ndecode_Lam; (* ! spezial CRATE all N1...23 connectet with L1...23 *)
    test_cycletun_N1;(* with cc32_TestModul *)
    test_naf;
    test_tm_register;
    read_counter;
    read_counter_fcl1_autoread;
    read_counter_fcl1_autoread_rdw;
  end;
  pciada_off;
end.


