#ifndef __PCIC32I_H__
#define __PCIC32I_H__
//-------------------------------------------------------------------------
// WIN95-driver for the  PCICC32 CAMAC-Interface of ARW Elektronik --------
// interrupt related stuff
//
// (c) 2000 ARW Elektronik
//
// this source code is published under GPL (Open Source). You can use, redistrubute and 
// modify it unless this header   is not modified or deleted. No warranty is given that 
// this software will work like expected.
// This product is not authorized for use as critical component in life support systems
// wihout the express written approval of ARW Elektronik Germany.
//
// Please announce changes and hints to ARW Elektronik
//
// what                                            who          when
// started                                         AR           17.03.2001
//

#include "pcic32.h"   // driver internal structures and constants

//-------------------------------------------------------------------------
// PROTOTYPES
//
void EnableIRQ(WORD *pwINTCSR);
void DisableIRQ(WORD *pwINTCSR);
DWORD vpcic32d_control_interrupts(PDIOCPARAMETERS ptr);
DWORD vpcic32d_install_irq_handler(PDIOCPARAMETERS ptr);
void  initInterrupts(VPCIC32_STATIC_STATUS *psVss);
BOOL Disable_Phys_IRQ(VPCIC32_STATIC_STATUS *psVss);
BOOL Enable_Phys_IRQ(VPCIC32_STATIC_STATUS *psVss);

#endif // __PCIC32I_H__