#ifndef __PCIVME_NI_95_H__
#define __PCIVME_NI_95_H__

//-------------------------------------------------------------------------------------------
// pcivme_ni_95.c - a ni labview dll skeleton for the ARW pcivme interface, win95+98
//
// (c) 1999-2002 ARW Elektronik, Germany
//
// this source code is published under GPL (Open Source). You can use, redistrubute and 
// modify it unless this header  is  not modified or deleted. No warranty is given that 
// this software will work like expected.
// This product is not authorized for use as critical component in life support systems
// wihout the express written approval of ARW Elektronik Germany.
//
// Please announce changes and hints to ARW Elektronik
// 
//
// what                                                              who    when
// first steps                                                       AR     07.11.1999
//

//-------------------------------------------------------------------------------------------
// FUNCTIONS
//
#include <windows.h>

//-------------------------------------------------------------------------------------------
// FUNCTIONS
//
int VMEinit95(const char *cszDeviceName, unsigned short nVMEMM, unsigned char ubAddressModifier, int *pnHandle);
int VMEread95(int nHandle, unsigned long ulAddress, unsigned char ubAccessWidth, unsigned long ulElementCount, void *pvBuffer);
int VMEwrite95(int nHandle, unsigned long ulAddress, unsigned char ubAccessWidth, unsigned long ulElementCount, void *pvBuffer);
int VMEaccessVIC95(int nHandle, unsigned char ubAccessMode, unsigned short uwAddress, unsigned char *ubContent);
int VMEreset95(int nHandle);
int VMETAS95(int nHandle, unsigned long ulAddress, unsigned char *ubResult);
int VMEinterrupt95(int nHandle, unsigned char *ubVector);
int VMEsysfailGet95(int nHandle, BOOLEAN *bResult);
int VMEsysfailSet95(int nHandle, BOOLEAN bForce);
int VMEclose95(int nHandle);

#endif /* __PCIVME_NI_95_H__ */