//-------------------------------------------------------------------------
//
// a universal menuing functions - screen output functions
// (c) 1999 ARW Elektronik
//
// this source code is published under GPL (Open Source). You can use, redistrubute and
// modify it unless this header  is  not modified or deleted. No warranty is given that
// this software will work like expected.
// This product is not authorized for use as critical component in life support systems
// wihout the express written approval of ARW Elektronik Germany.
//
// Please announce changes and hints to ARW Elektronik
//
// what							who    when
// first steps						AR     22.11.97
//
#include <stdio.h>
#include <screen.h>
#include <conio.h>
#include <dos.h>

#define MAX_X_POS 70
#define MAX_Y_POS 25

void sc_init(void)
{
}

void sc_deinit(void)
{
  clrscr();
}

void sc_high(void)
{
}

void sc_low(void)
{
}

int sc_maxxpos()
{
  return MAX_X_POS;
}

int sc_maxypos()
{
  return MAX_Y_POS;
}

void sc_getpos(int *x_pos, int *y_pos)
{
  *x_pos = wherex();
  *y_pos = wherey();
}

void sc_goto(int x_pos, int y_pos)
{
  x_pos = (x_pos > MAX_X_POS) ? MAX_X_POS : x_pos;
  y_pos = (y_pos > MAX_Y_POS) ? MAX_Y_POS : y_pos;
  gotoxy(x_pos, y_pos);
}

void sc_clear(void)
{
  clrscr();
}

void sc_home(void)
{
  sc_goto(1,1);
}

void sc_clreol(void)
{
  clreol();
}

void sc_delay(int msec)
{
  delay(msec);
}