#ifndef __SCREEN_H__
//-------------------------------------------------------------------------
//
// part of generalized menu functions. screen output functions
// (c) 1999 ARW Elektronik
//
// this source code is published under GPL (Open Source). You can use, redistrubute and
// modify it unless this header  is  not modified or deleted. No warranty is given that
// this software will work like expected.
// This product is not authorized for use as critical component in life support systems
// wihout the express written approval of ARW Elektronik Germany.
//
// Please announce changes and hints to ARW Elektronik
//
// what							who    when
// first steps						AR     10.10.98
//

extern void sc_init(void);
extern void sc_deinit(void);
extern void sc_high(void);
extern void sc_low(void);
extern int  sc_maxxpos(void);
extern int  sc_maxypos(void);
extern void sc_getpos(int *x_pos, int *y_pos);
extern void sc_clear(void);
extern void sc_home(void);
extern void sc_goto(int x_pos, int y_pos);
extern void sc_clreol(void);
extern void sc_delay(int msec);

#define __SCREEN_H__
#endif