program testall;(* VDIS *)
uses crt,dos,_pcivme,_hexnum;

var    ch        : char;
       datar     :longint;
const  pciada_nr = 0;
       d         = 0;
                        
       VD2_STATUS  = $8800;
       VD2_INTREG  = VD2_STATUS + $10;
       VD2_SOIC_VC = VD2_STATUS + $20;
       VD2_AREG    = VD2_STATUS + $30;
       VD2_AREG32  = VD2_STATUS + $32;
       VD2_DREG    = VD2_STATUS + $40;
       VD2_COUNT   = VD2_STATUS + $80;
       VMEMMSHORT  = $aa00;

procedure wr32(segment,offset:word; d32:longint); far; external;
procedure rd32(segment,offset:word; var v:longint); far; external;
{$L _RW32.OBJ}


(*tstcounter*******************************************************)
Procedure tstcounter;
var    vmeadr,dataw,i  : longint;

begin
  clrscr;
  PCIADA_suchen(pciada_nr);     (* erste PCIADA-Karte suchen *)
  portw[IOBASE + $28] := $0022; (* prefetch_on*)

  PCIADA_tst(pciada_nr);
  VMEMM_test;                     (* test VME-Power u. Kabel*)
  VMEMM_init;                      (* PCIADA-on + VME-Reset + SYSFAIL-Reset*)
  wr_ispl_stat;
  wr_ispl_irq;
  wr_plx_int_reg;
  dataw      := 0;
  writeln(' ----- tstcounter -----');
  writeln('press any key to exit:');

  mem[VICBASE:$b7] := $29;     (*  write adressmodifier into VIC *)
  wr32(VMEMMBASE,adrvmeadr_reg,VD2_COUNT);
{  the next line is optinal }
{  portw[IOBASE + $50] := $4182; (* pciada_autoread_on*) }

  portw[IOBASE + $28] := $0032; (* prefetch 8 longword on*)
  repeat
    for i := 0 to 15 do
    begin
      rd32(VMEBASE,($8880+i*4)and $0ffc,datar);
    end;
  until keypressed;
  ch := readkey;
  portw[IOBASE + $50] := $4186; (* pciada_autoread_off *)
  portw[IOBASE + $28] := $0022; (* prefetch_off*)

  pciada_autoread_off;
  pciada_off;

end;
(*main-programm*********)
begin

tstcounter;

end.

