{arw JUL 2002 / this program runs with PCIADA in higher or lower memory
 using only the function from _unreal.pas}


program testall ;(* optic test A01..31,D00..31,AM0..5 mit VDIS *)
uses crt,dos,_pcivmex,_hexnum,_unreal;

var    ch        : char;
const  pciada_nr = 0;
       version   = 'VDIS2-Ver.1.0';
       d         = 0;
                        
       VD2_STATUS  = $8800;
       VD2_INTREG  = VD2_STATUS + $10;
       VD2_SOIC_VC = VD2_STATUS + $20;
       VD2_AREG    = VD2_STATUS + $30;
       VD2_AREG32  = VD2_STATUS + $32;
       VD2_DREG    = VD2_STATUS + $40;
       VD2_COUNT   = VD2_STATUS + $80;
       VMEMMSHORT  = $aa00;

procedure bittest;

var     adr,data : longint;

begin                                      
  clrscr;
  VMEMM_init;                     (* PCIADA-on + VME-Reset + SYSFAIL-Reset*)
  wr_ispl_stat;
  wr_ispl_irq;                      
  wr_plx_int_reg;
  writeln(' ----- bittst -----');
  writeln('press any key to exit:');
  repeat
    VME_wr(0,0,0,d32);delay(d);
    data := 1;
    VME_wr(data,0,0,d32);delay(d);
    repeat
      data := data * 2;
      VME_wr(data,0,0,d32);delay(d);
    until data = $80000000;
    VME_wr(0,0,0,d32);  delay(d);
    adr := 2;
    VME_wr(0,adr,0,d16);  delay(d);
    adr := 2;
    VME_wr(0,adr,0,d32);  delay(d);
    repeat
      adr := adr * 2;
      VME_wr(0,adr,0,d32); delay(d);
    until adr = $80000000;
    VME_wr(0,0,0,d32);  delay(d);
    adr := 1;
    VME_wr(0,0,adr,d32); delay(d);
    repeat
      adr := adr * 2;
      VME_wr(0,0,adr,d32); delay(d);
    until adr = $20;
  until keypressed;
  ch := readkey;
  pciada_off;
end;

Procedure tstlong;
var    vmeadr,dataw,datar,i  : longint;

begin
  clrscr;
  VMEMM_init;                     (* PCIADA-on + VME-Reset + SYSFAIL-Reset*)

  wr_ispl_stat;
  wr_ispl_irq;
  wr_plx_int_reg;
  dataw      := $0000;
  vmeadr     := $0;
  writeln(' ----- tstlong -----');
  writeln('press any key to exit:');
  repeat
  for i := 1 to $10000 do
  begin
    VME_WR(dataw,VD2_DREG,$29,d32);
    VME_RD(datar,VD2_DREG,$29,d32);
      if dataw <> datar then
      begin
        writeln('dataw  ',num2bin(dataw,8));
        writeln('datar  ',num2bin(datar,8));
        delay(1000);
      end;
      dataw := (dataw+1777);
    end;
  until keypressed;
  ch := readkey;
  pciada_off;
end;

(*tstword*****************************************************************)
procedure tstword;
var   vmeadr,dataw,datar                    : longint;
      chr                                   : char;
begin
  clrscr;
  VMEMM_init;                     (* PCIADA-on + VME-Reset + SYSFAIL-Reset*)
  wr_ispl_stat;
  wr_ispl_irq;
  wr_plx_int_reg;
  dataw      := $0000;
  memw[VICBASE:$0] := $20;
  writeln(' ----- testword -----');
  writeln('press any key to exit:');
  repeat
  for dataw := 1 to $ffff do
  begin
    VME_WR(dataw,VD2_DREG,$29,d16);
    VME_RD(datar,VD2_DREG,$29,d16);
      if dataw <> datar then
      begin
        writeln('dataw  ',num2bin(dataw,8));
        writeln('datar  ',num2bin(datar,8));
        delay(1000);
      end;
    end;
  until keypressed;
  ch := readkey;
  pciada_off;
end;
(*   TST BYTE ------------------------------- *)

procedure tstbyte;
var    vmeadr,dataw,datar                   : longint;

begin
  clrscr;
  VMEMM_init;                  (* PCIADA-on + VME-Reset + SYSFAIL-Reset*)

  wr_ispl_stat;
  wr_ispl_irq;
  wr_plx_int_reg;

  dataw      := $0000;                              
  vmeadr     := $0;
  writeln(' ----- tstbyte -----');
  writeln('press any key to exit:');
  repeat
    VME_WR(dataw,vmeadr,$39,d8);
    VME_RD(datar,vmeadr,$39,d8);
    if dataw <> datar then
    begin
      writeln('dataw ',num2bin(dataw,8));
      writeln('datar ',num2bin(datar,8));
      writeln;
      delay(1000);
    end;
    vmeadr := vmeadr-1;
    dataw := (dataw+1) and $00ff;
  until keypressed;
  ch := readkey;
end;

(*tstcounter*******************************************************)
Procedure tstcounter;
var    vmeadr,dataw,datar,i  : longint;

begin
  clrscr;
  VMEMM_init;                     (* PCIADA-on + VME-Reset + SYSFAIL-Reset*)
  wr_ispl_stat;
  wr_ispl_irq;
  wr_plx_int_reg;
  dataw      := 0;
  writeln(' ----- tstcounter -----');
  writeln('press any key to next test:');

  repeat
  for i := 1 to $10000 do
  begin
    VME_RD(datar,VD2_COUNT,$29,d32);
      if dataw <> datar then
      begin
        writeln('dataw  ',num2bin(dataw,8));
        writeln('datar  ',num2bin(datar,8));
        delay(1000);
      end;
      dataw := (dataw+1);
    end;
  until keypressed;
  ch := readkey;
  pciada_off;
end;
(*tstdreg*******************************************************)
Procedure tstdreg;
var    vmeadr,dataw,datar,i  : longint;

begin
  clrscr;
  VMEMM_init;                     (* PCIADA-on + VME-Reset + SYSFAIL-Reset*)
  wr_ispl_stat;
  wr_ispl_irq;
  wr_plx_int_reg;
  dataw      := 0;
  writeln(' ----- tstdreg -----');
  writeln('press any key to exit:');
  repeat
  for i := 1 to $10000 do
  begin
    VME_WR(dataw,VD2_DREG,$29,d32);
    VME_RD(datar,VD2_DREG,$29,d32);
      if dataw <> datar then
      begin
        writeln('dataw  ',num2bin(dataw,8));
        writeln('datar  ',num2bin(datar,8));
        delay(1000);
      end;
      dataw := (dataw+1);
    end;
  until keypressed;
  ch := readkey;
  pciada_off;
end;

(*tstint1*****************************************)
procedure tstint1;
var    vmeadr,dataw,datar         : longint;
       keychar : char;
       vector  : byte;
       dummy   : string;
begin
  clrscr;
  VMEMM_init;                  (* PCIADA-on + VME-Reset + SYSFAIL-Reset usw.*)
  wr_ispl_stat;
  wr_ispl_irq;
  wr_plx_int_reg;
  writeln(' ----- tst interrupt von VMEMM -----');
    (* write to VIC-Chip over VMEbus > VIC generiert _BERR !!! *)
  VME_WR($0c88,VD2_INTREG,$29,d16); (* write to intreg vdis2 *)
  VME_WR($1234,VMEMMSHORT,$29,d16);
   writeln('look  _BERR-LED + IRQ-LED then press Reset-Switch!');
  writeln(chr($07),'press any key to go!');
  repeat until keypressed;
    keychar := readkey;              
  wr_ispl_irq;                     
  wr_plx_int_reg;
  RD_vector(vector);
  writeln('interrupt-vector = ',num2hex(vector,2));
  RD_vector(vector);
  writeln('interrupt-vector = ',num2hex(vector,2));
  RD_vector(vector);
  writeln('interrupt-vector = ',num2hex(vector,2));
  RD_vector(vector);
  writeln('interrupt-vector = ',num2hex(vector,2));
  writeln(chr($07));
  write('press any key to exit:');
  repeat until keypressed;
   ch := readkey;
  pciada_off;
end;

procedure tstintreg;
var    vmeadr,dataw,datar         : longint;
       keychar : char;          
       vector  : byte;
       dummy   : string;

begin
  clrscr;
  writeln('test-Interruptregister');
  VMEMM_init;                    (* PCIADA-on + VME-Reset + SYSFAIL-Reset usw.*)
  dataw := 0;                 
  repeat
    VME_wr(dataw,VD2_INTREG,$29,d16); (* write status to vdis2 *)
    dataw := dataw + 1;
    delay(1);
  until keypressed;          
  ch := readkey;
end;
                                


 procedure tstpower;
var    vmeadr,dataw,datar         : longint;
       keychar : char;          
       vector  : byte;
       dummy   : string;

begin
  clrscr;
  writeln('test-Power');
  VMEMM_init;                    (* PCIADA-on + VME-Reset + SYSFAIL-Reset usw.*)
  dataw := 0;
  repeat
     VME_RD(datar,VD2_AREG32,$29,d16);
        writeln('datar  ',num2bin(datar,4));
    delay(1000);
  until keypressed;
  ch := readkey;
end;                          

(*main-programm*********)
  begin
  clrscr;
  PCIVME_tstandset(pciada_nr,version);
    bittest;
    tstlong;
    tstword;
    tstbyte;
  writeln('Have a VDIS2 for more tests?  (y,n)');
  repeat until keypressed; ch := readkey;
  ch := upcase(ch);
  if (ch = 'Y') or (ch = 'Z') then
  begin
    tstcounter;
    tstdreg;
    tstint1;
    tstintreg;
    tstpower;
    writeln('test ready >> press any key');
    repeat until keypressed; ch := readkey;
  end;
end.

