{arw JUL 2002 / this program runs with PCIADA in higher or lower memory
 using only the function from _unreal.pas}

program   testall ;(* optic test A01..31,D00..31,AM0..5 mit VDIS *)
uses      crt,dos,_pcivmex,_hexnum,_unreal;

var       ch        : char;
const     pciada_nr = 0;
          d         = 0;
          version   = 'VMEMMX-Ver.1.1';
procedure bittest;

var       adr,data : longint;

begin
  clrscr;
  VMEMM_init;                     (* PCIADA-on + VME-Reset + SYSFAIL-Reset*)
  writeln(' ----- bittst -----');
  writeln('press any key to next test:');
  repeat
    VME_wr(0,0,0,d32);delay(d);
    data := 1;
    VME_wr(data,0,0,d32);delay(d);
    repeat
      data := data * 2;
      VME_wr(data,0,0,d32);delay(d);
    until data = $80000000;
    VME_wr(0,0,0,d32);  delay(d);
    adr := 2;
    VME_wr(0,adr,0,d16);  delay(d);
    adr := 2;
    VME_wr(0,adr,0,d32);  delay(d);
    repeat
      adr := adr * 2;
      VME_wr(0,adr,0,d32); delay(d);
    until adr = $80000000;
    VME_wr(0,0,0,d32);  delay(d);
    adr := 1;
    VME_wr(0,0,adr,d32); delay(d);
    repeat
      adr := adr * 2;
      VME_wr(0,0,adr,d32); delay(d);
    until adr = $20;
  until keypressed;
  ch := readkey;
  pciada_off;
end;

Procedure tstlong;
var    vmeadr,dataw,datar,i  : longint;

begin
  clrscr;
  VMEMM_init;                     (* PCIADA-on + VME-Reset + SYSFAIL-Reset*)

  wr_ispl_stat;
  wr_ispl_irq;
  wr_plx_int_reg;

  dataw      := $0000;
  vmeadr     := $0;
  writeln(' ----- tstlong -----');
  writeln('press any key to next test:');
  repeat
  for i := 1 to 10000 do
  begin
    VME_WR(dataw,vmeadr,$09,d32);
    VME_RD(datar,vmeadr,$09,d32);
      if dataw <> datar then
      begin
        writeln('dataw  ',num2bin(dataw,8));
        writeln('datar  ',num2bin(datar,8));
        delay(1000);
      end;
      vmeadr := vmeadr-12345;
      dataw := (dataw+54321);
    end;
  until keypressed;
  ch := readkey;
  pciada_off;
end;

(*tstword*****************************************************************)
procedure tstword;
var   vmeadr,dataw,datar                    : longint;
      chr                                   : char;
begin
  clrscr;
  VMEMM_init;                     (* PCIADA-on + VME-Reset + SYSFAIL-Reset*)

  wr_ispl_stat;
  wr_ispl_irq;
  wr_plx_int_reg;

  dataw      := $0000;
  vmeadr     := $0;
  wrx8(VICBASE+$0,$20);
  writeln(' ----- testword -----');
  writeln('press any key to next test:');
  repeat    
    VME_WR(dataw,vmeadr,$39,d16);
    VME_RD(datar,vmeadr,$39,d16);
    if dataw <> datar then
    begin
      writeln('dataw    ',num2bin(dataw,8));
      writeln('datar #1 ',num2bin(datar,8));
      VME_RD(datar,vmeadr,$39,d16);
      writeln('datar #2 ',num2bin(datar,8));
      writeln('vmeadr   ',num2bin(vmeadr,8));
      writeln('*');
      delay(2000);
    end;
    vmeadr := vmeadr-1;
    dataw := (dataw+1) and $0000ffff;
  until keypressed;
  ch := readkey;
  pciada_off;
end;

(*tstbyte*******************************************************)
procedure tstbyte;
var    vmeadr,dataw,datar                   : longint;

begin
  clrscr;
  VMEMM_init;                  (* PCIADA-on + VME-Reset + SYSFAIL-Reset*)

  wr_ispl_stat;
  wr_ispl_irq;
  wr_plx_int_reg;

  dataw      := $0000;                              
  vmeadr     := $0;
  writeln(' ----- tstbyte -----');
  writeln('press any key to next test:');
  repeat
    VME_WR(dataw,vmeadr,$39,d8);
    VME_RD(datar,vmeadr,$39,d8);
    if dataw <> datar then
    begin
      writeln('dataw ',num2bin(dataw,8));
      writeln('datar ',num2bin(datar,8));
      writeln;
      delay(1000);
    end;
    vmeadr := vmeadr-1;
    dataw := (dataw+1) and $00ff;
  until keypressed;
  ch := readkey;
end;

(*tstint1*****************************************)
procedure tstint1;
var    vmeadr,dataw,datar         : longint;
       keychar : char;
       vector  : byte;
       dummy   : string;
begin
  clrscr;
  VMEMM_init;                  (* PCIADA-on + VME-Reset + SYSFAIL-Reset usw.*)

  wr_ispl_stat;
  wr_ispl_irq;
  wr_plx_int_reg;
  writeln(' ----- tst interrupt von VMEMM -----');
    (* write to VIC-Chip over VMEbus > VIC generiert _BERR !!! *)
  VME_WR($0b88,$5510,$29,d16); (* write to intreg vdis2 *)
  VME_WR($1234,$aa00,$29,d16);
  writeln('look  _BERR-LED + IRQ-LED then press Reset-Switch!');
  writeln(chr($07),'press any key to go!');
  repeat until keypressed;
   keychar := readkey;
  wr_ispl_irq;                 
  wr_plx_int_reg;
  RD_vector(vector);
  writeln('interrupt-vector = ',num2hex(vector,2));
  RD_vector(vector);
  writeln('interrupt-vector = ',num2hex(vector,2));
  RD_vector(vector);
  writeln('interrupt-vector = ',num2hex(vector,2));
  RD_vector(vector);
  writeln('interrupt-vector = ',num2hex(vector,2));
  writeln(chr($07));
  write('press any key to next test:');
  repeat until keypressed;

   keychar := readkey;
  pciada_off;                     
end;

procedure tstint2;
{Programm >>> hier wird der Timout-Interrupt auf dem PCIADA-Board getestet}

var    vmeadr,dataw,datar         : longint;
       keychar : char;
       vector  : byte;
begin
  clrscr;
  VMEMM_init;                  (* PCIADA-on + VME-Reset + SYSFAIL-Reset*)
               
  wr_ispl_stat;
  wr_ispl_irq;
  wr_plx_int_reg;
  writeln(' ----- tst interrupt von PCIADA -----');
  writeln('SWITCH VME-POWER OFF and press any key to go!');
  repeat until keypressed;
  keychar := readkey;
  VME_WR($1234,$0000,$29,d16);(* generiert PCIADA interrupt *) 
  wr_plx_int_reg;
  RD_vector(vector);
  writeln('interrupt-vector = ',num2hex(vector,2));
  wr_plx_int_reg;
  writeln(chr($07));
  writeln('SWITCH VME-POWER ON and press any key to next test:');
  repeat until keypressed;
  keychar := readkey;
  pciada_off;
end;

(* *************************************** *)

procedure tstreset;
var    vmeadr,dataw,datar         : longint;
       x                           : integer;
       keychar : char;
       vector  : byte;
begin
  clrscr;
  VMEMM_init;                   (* PCIADA-on + global-reset + SYSFAIL-reset*)
{ wr_ispl_stat;
  wr_ispl_irq;
  wr_plx_int_reg;}

  writeln(' ----- tst vic reset -----');
  delay(1000);

  x:=0;
  wrx16(VMEMMBASE+adrvmemm_reset,$a);    (* global-reset *)
{ memw[MEMBASE:adrvmemm_reset] := $5;  (* internal-reset *)
  mem[vicbase:$e3] := $f0;            (* VIC SYSTEM RESET *)
} repeat                        (* wait-loop to VME-Reset finish *)
    wrx8(VICBASE+$b7,0);      (* adressmodifier in VIC schreiben *)
    x:=x+1;
    delay(1);
  until rdx8(VICBASE+$b7) = 0;
    writeln(x);
    wr_plx_int_reg;(* der VIC-Chip generiert im RESET-Status nach 32us acknowlege!!!
                                       INT2 wird nicht aktiv weil PCIADA timeout =35 us *)
    write(chr($7)); writeln('press any key to next test:');
  repeat until keypressed;
  keychar := readkey;
  pciada_off;
end;

(*tstirq*************************************** *)

procedure tstirq;

var    vmeadr,dataw,datar,i         : longint;
       dummy : string;
       vector  : byte;

 begin
  clrscr;
  VMEMM_init;            (* PCIADA-on + VME-Reset + SYSFAIL-Reset usw.*)
  delay(1);
  writeln(' ----- tst irq -----');

  PCIADA_off;         (* bei acces ohne VMEMM ist hier int2 schon aktiv *)
  PCIADA_on;          (* jetzt nicht mehr *)
  PCIADA_enable_irq;

(* Achtung wenn zuviele Interrupts nacheinander kommen werden nicht alle
   erkannt! Unter Windows werden weniger gesehen. !! *)

  portw[IOBASE + $4c] := $00c4;    (* 1 interrupt via PLX-Register *)
  portw[IOBASE + $4c] := $00c4;    (* 1 interrupt via PLX-Register *)
  portw[IOBASE + $4c] := $00c4;    (* 1 interrupt via PLX-Register *)
  wrx8(VICBASE+$b7,0);           (* 2 interrupt > VMEMM not connected *)
  wrx8(VICBASE+$b7,0);
  VME_WR(dataw,vmeadr,$09,d32);    (* 2 interrupt > VMEMM not connected *)
  VME_WR(dataw,vmeadr,$09,d32);
  writeln(intcount);
  delay(1); (* delay > programm ist schneller als irq service-routine!!! *)
  writeln(intcount);
  write(chr($7));
  writeln('press any key to next test:');
  repeat until keypressed; ch := readkey;
  PCIADA_disable_irq;
  pciada_off;
end;

(*main-programm*********)
begin
  clrscr;
  PCIVME_tstandset(pciada_nr,version);  (* PCIADA-Karte suchen u. Adressen def.*)
  tstint1;
  tstint2;
  tstreset;
  writeln('have a VDIS for more tests?  (y,n)');
  repeat until keypressed; ch := readkey;
  ch := upcase(ch);
  if (ch = 'Y') or (ch = 'Z') then
  begin
    bittest;
    tstlong;
    tstword;
    tstbyte;
    tstirq;
    writeln('test ready >> press any key');
    repeat until keypressed; ch := readkey;
  end;

end.
