UNIT _HEXNUM;

INTERFACE


	FUNCTION Num2Hex   (num     : LongInt;
                            digits  : Integer) :STRING;
       
        FUNCTION Hex2Num   (hex : string) : LongInt;

        FUNCTION Hex2bin   (hex : string) : string;

        FUNCTION Num2bin   (num     : LongInt;
                            digits  : Integer) :STRING;


IMPLEMENTATION

	FUNCTION Hex2bin;
	VAR  Zeichen,bin : string;
              n, digits  : integer;
        BEGIN
          bin := ' ';
          delete(hex,1,1);
          digits := length(hex);
          For n := 1 to digits do
            begin
              zeichen := copy(hex,n,1);
              if zeichen = '0'then bin := concat(bin,' 0000');
              if zeichen = '1'then bin := concat(bin,' 0001');
              if zeichen = '2'then bin := concat(bin,' 0010');
              if zeichen = '3'then bin := concat(bin,' 0011');
              if zeichen = '4'then bin := concat(bin,' 0100');
              if zeichen = '5'then bin := concat(bin,' 0101');
              if zeichen = '6'then bin := concat(bin,' 0110');
              if zeichen = '7'then bin := concat(bin,' 0111');
              if zeichen = '8'then bin := concat(bin,' 1000');
              if zeichen = '9'then bin := concat(bin,' 1001');
              if zeichen = 'A'then bin := concat(bin,' 1010');
              if zeichen = 'B'then bin := concat(bin,' 1011');
              if zeichen = 'C'then bin := concat(bin,' 1100');
              if zeichen = 'D'then bin := concat(bin,' 1101');
              if zeichen = 'E'then bin := concat(bin,' 1110');
              if zeichen = 'F'then bin := concat(bin,' 1111');
            end;
	    Hex2bin := bin;
        END;

	FUNCTION Num2Hex;
		VAR  dig, digit : Integer;
                     hex        : String;
	BEGIN
		hex := '';
		digit := 1;
		REPEAT
		 dig := num and $f;
                 IF dig > 9 THEN hex := concat(char(dig + 55), hex)
		            ELSE hex := concat(char(dig + 48), hex);
                 num := num shr 4;
                 digit := digit + 1;
		UNTIL (digit > digits) AND (num = 0);
		num2hex := concat('$', hex);
	END;

	FUNCTION Hex2Num;
		 VAR
			  n : Integer;
			num : LongInt;
	BEGIN
		num := 0;
		IF hex[1] = '$' THEN
		FOR n := 2 TO length(hex) DO
		  CASE hex[n] OF
		    '0', '1', '2', '3', '4', '5', '6', '7', '8', '9' : 
		    num := num * 16 + ord(hex[n]) - 48;
		    'A', 'B', 'C', 'D', 'E', 'F' : 
		    num := num * 16 + ord(hex[n]) - 55;
		    'a', 'b', 'c', 'd', 'e', 'f' : 
		    num := num * 16 + ord(hex[n]) - 87;
		  END
		ELSE
		  FOR n := 1 TO length(hex) DO
		    CASE hex[n] OF
		      '0', '1', '2', '3', '4', '5', '6', '7', '8', '9' : 
		      num := num * 10 + ord(hex[n]) - 48;
		    END;
		    Hex2Num := num;
	        END;

	        FUNCTION Num2bin;
                     var hex,bin        : String;
                begin
                hex := Num2Hex(num,digits);
                bin := Hex2bin(hex);
                Num2bin := bin;
                end;
        END.