USES   crt,DOS,_hexnum,_pcivme;
var    vmem : ARRAY[1..15] of longint;

var    vmeadr,dataw,datar,datahw,datalw,i     : longint;

const  pciada_nr  = 0;

(* VAR IOBASE, MEMBASE, VICBASE, VECBASE u. VMEBASE def. by UNIT _pcivme *)
(* *************************************** *)

procedure wr32(segment,offset:word; d32:longint); far; external;
procedure rd32(segment,offset:word; var v:longint); far; external;
{$L _RW32.OBJ}

begin

  clrscr;
  PCIADA_suchen(pciada_nr);(* PCIADA-Karte suchen *)
  VMEMM_test;              (* test VME-Power u. Kabel*)
  VMEMM_init;          (* PCIADA-on + VME-Reset + SYSFAIL-Reset + VIC ini*)

  wr_ispl_stat;
  wr_ispl_irq;
  wr_plx_int_reg;

(*  the next 3 lines is a demo for fast a32/d32 vme-acces
    adr is $12345678 and data is $87654321 *)
  mem[VICBASE:$b7]  := $09;               (* write byte to vic AMSR*)
      (*  segment, offset, data *)
  wr32(VMEMMBASE,$8,$12345000);          (* load adrreg with 123456xxx *)
  wr32(VMEBASE,$0678,$87654321);       (* write a32/d32 to vme *)
  dataw      := $0;

  pciada_autoread_off;
  repeat
    for i := 1 to 9 do
    begin
    rd32(VMEBASE,$8,vmem[i]);   (* read long adrreg from ispl *)
    end;

    for i:=1 to 1000 do begin end;
  until keypressed;
  pciada_off;
end.
