(* PCIADA > VMEMM > VMEADA > CC32 *)

USES   crt,DOS,_hexnum,_pcivme;
                              
var    vmeadr,dataw,datar                   : longint;
       i,j                                    : integer;
       N : 0..31;
       A : 0..15;
       F : 0..31;
       NAF : word;
const  pciada_nr = 0;

(* *************************************** *)
begin
  n:=0;
  a:=0;
  f:=0;             

  clrscr;
  PCIADA_suchen(pciada_nr);    (* PCIADA-Karte suchen *)
  PCIADA_tst(pciada_nr);
  VMEMM_test;                  (* test VME-Power u. Kabel*)
  VMEMM_init;                  (* PCIADA-on + VME-Reset + SYSFAIL-Reset*)

  wr_ispl_stat;          
  wr_ispl_irq;                    
  wr_plx_int_reg;             
  dataw      := 0;
  datar      := 0;
  vmeadr     := $550000;

  VME_wr($1000,vmeadr+$C,$39,d16);    (* read VMEADA - Status *)
  VME_RD(datar,vmeadr+$C,$39,d16);    (* read VMEADA - Status *)
  writeln('VMEADA-Status            ',num2bin(datar,4));
  VME_RD(datar,vmeadr,$39,d16);
  writeln('datar            ',num2bin(datar,4));
  delay(2000);

  NAF:= 27 shl 10 + 0 shl 6 + 0 shl 2;
  VME_wr(0,vmeadr+NAF,$39,d32);        (*  set inhibit *)

  NAF:= 0 shl 10 + 2 shl 6 + 0 shl 2;
  VME_wr(0,vmeadr+NAF,$39,d32);        (* camac C + Inhibit reset *)

  n := 1;
  NAF:= 24 shl 10 + 1 shl 6 + 5 shl 2;
repeat
  for i := 0 to 10000 do
  begin

    VME_wr(15,vmeadr+(24 shl 10 + 1 shl 6),$39,d32);        (* reset cc32 *)
    VME_rd(datar,vmeadr+NAF,$39,d32);     
    VME_rd(datar,vmeadr+NAF,$39,d32);    
    VME_rd(datar,vmeadr+NAF,$39,d32);       
    VME_rd(datar,vmeadr+NAF,$39,d32);    
    VME_rd(datar,vmeadr+NAF,$39,d32);    
    VME_rd(datar,vmeadr+NAF,$39,d32);     
    VME_rd(datar,vmeadr+NAF,$39,d32);      
    VME_rd(datar,vmeadr+NAF,$39,d32);      
    VME_rd(datar,vmeadr+NAF,$39,d32);     
    VME_rd(datar,vmeadr+NAF,$39,d32);      
    VME_rd(datar,vmeadr+NAF,$39,d32);      
    VME_rd(datar,vmeadr+NAF,$39,d32);      
  end;
  write('*');
until keypressed;
end.
