#ifndef __VME_H__
#define __VME_H__

//------------------------------------------------------------------------------------------
// vme.h - some constants about VME address modifiers in a more readable kind
// (c) 1999-2002 ARW Elektronik
//
// this source code is published under GPL (Open Source). You can use, redistrubute and 
// modify it unless this header   is not modified or deleted. No warranty is given that 
// this software will work like expected.
// This product is not authorized for use as critical component in life support systems
// wihout the express written approval of ARW Elektronik Germany.
//
// Please announce changes and hints to ARW Elektronik
// 
// ***** Please note: this file is a copy of the current vme.h file out of
// ***** the pcivme folder. It is copied only for convienience of compiling.
//
// $Log: Vme.h,v $
// Revision 1.3  2002/10/27 17:37:06  klaus
// Copy note added for duplicated files
//
// Revision 1.2  2002/10/27 17:32:18  klaus
// CVS log added, WINNT 2 Gbyte file size circumvent
//
// what                                                              who    when
// finished first release to use with the PCIVME interface of ARW    AR     22.03.1999
//

typedef WORD ADDRESS_MODIFIER;

#define Std_Sup_Data        (ADDRESS_MODIFIER)0x3d
#define Std_Sup_Prog        (ADDRESS_MODIFIER)0x3e
#define Std_NoPriv_Data     (ADDRESS_MODIFIER)0x39
#define Std_NoPriv_Prog     (ADDRESS_MODIFIER)0x3a

#define Short_Sup           (ADDRESS_MODIFIER)0x2d
#define Short_NoPriv        (ADDRESS_MODIFIER)0x29

#define Ext_Sup_Data        (ADDRESS_MODIFIER)0x0d
#define Ext_Sup_Prog        (ADDRESS_MODIFIER)0x0e
#define Ext_NoPriv_Data     (ADDRESS_MODIFIER)0x09
#define Ext_NoPriv_Prog     (ADDRESS_MODIFIER)0x0a

#endif

//-------------------------------------------------------------------------------------------
//-------------------------------------------------------------------------------------------
//-------------------------------------------------------------------------------------------
