#ifndef __PCIVME_NI_NT_H__
#define __PCIVME_NI_NT_H__

//-------------------------------------------------------------------------------------------
// pcivme_ni_NT.c - a ni labview dll skeleton for the ARW pcivme interface, winNT
//
// (c) 1999-2002 ARW Elektronik, Germany
//
// this source code is published under GPL (Open Source). You can use, redistrubute and 
// modify it unless this header  is  not modified or deleted. No warranty is given that 
// this software will work like expected.
// This product is not authorized for use as critical component in life support systems
// wihout the express written approval of ARW Elektronik Germany.
//
// Please announce changes and hints to ARW Elektronik
// 
//
// what                                                              who    when
// first steps                                                       AR     07.11.1999
//

//-------------------------------------------------------------------------------------------
// FUNCTIONS
//
#include <windows.h>

//-------------------------------------------------------------------------------------------
// FUNCTIONS
//
int VMEinitNT(const char *cszDeviceName, unsigned short nVMEMM, unsigned char ubAddressModifier, int *pnHandle);
int VMEreadNT(int nHandle, unsigned long ulAddress, unsigned char ubAccessWidth, unsigned long ulElementCount, void *pvBuffer);
int VMEwriteNT(int nHandle, unsigned long ulAddress, unsigned char ubAccessWidth, unsigned long ulElementCount, void *pvBuffer);
int VMEaccessVICNT(int nHandle, unsigned char ubAccessMode, unsigned short uwAddress, unsigned char *ubContent);
int VMEresetNT(int nHandle);
int VMETASNT(int nHandle, unsigned long ulAddress, unsigned char *ubResult);
int VMEinterruptNT(int nHandle, unsigned char *ubVector);
int VMEsysfailGetNT(int nHandle, BOOLEAN *bResult);
int VMEsysfailSetNT(int nHandle, BOOLEAN bForce);
int VMEcloseNT(int nHandle);

#endif /* __PCIVME_NI_NT_H__ */