#ifndef __PCIVME_NI_H__
#define __PCIVME_NI_H__

//-------------------------------------------------------------------------------------------
// pcivme_ni.h - header for ni-labview dll for ARW pcivme interface
//
// (c) 1999-2002 ARW Elektronik, Germany
//
// this source code is published under GPL (Open Source). You can use, redistrubute and 
// modify it unless this header  is  not modified or deleted. No warranty is given that 
// this software will work like expected.
// This product is not authorized for use as critical component in life support systems
// wihout the express written approval of ARW Elektronik Germany.
//
// Please announce changes and hints to ARW Elektronik
// 
//
// $Log: pcivme_ni.h,v $
// Revision 1.2  2002/10/27 17:05:33  klaus
// CVS log added, file addressing bug > 2 Gbtye circumvent
//
// what                                                              who    when
// first steps                                                       AR     17.11.1999
// modified for use with C++                                         AR     08.06.2002
//

//-------------------------------------------------------------------------------------------
// FUNCTIONS
//
#ifdef __cplusplus
extern "C"
{
#endif

int __declspec(dllexport) VMEinit(const char *cszDeviceName, unsigned short nVMEMM, unsigned char ubAddressModifier, int *pnHandle);
int __declspec(dllexport) VMEread(int nHandle, unsigned long ulAddress, unsigned char ubAccessWidth, unsigned long ulElementCount, void *pvBuffer);
int __declspec(dllexport) VMEwrite(int nHandle, unsigned long ulAddress, unsigned char ubAccessWidth, unsigned long ulElementCount, void *pvBuffer);
int __declspec(dllexport) VMEaccessVIC(int nHandle, unsigned char ubAccessMode, unsigned short uwAddress, unsigned char *ubContent);
int __declspec(dllexport) VMEreset(int nHandle);
int __declspec(dllexport) VMETAS(int nHandle, unsigned long ulAddress, unsigned char *ubResult);
int __declspec(dllexport) VMEinterrupt(int nHandle, unsigned char *ubVector);
int __declspec(dllexport) VMEsysfailGet(int nHandle, BOOLEAN *bResult);
int __declspec(dllexport) VMEsysfailSet(int nHandle, BOOLEAN bForce);
int __declspec(dllexport) VMEclose(int nHandle);

#ifdef __cplusplus
}
#endif

#endif /* __PCIVME_NI_H__ */