#ifndef __TASTATUR_H__
//-------------------------------------------------------------------------
//
// part of generalized menu functions. keyboard input functions
// (c) 1999 ARW Elektronik
//
// this source code is published under GPL (Open Source). You can use, redistrubute and
// modify it unless this header  is  not modified or deleted. No warranty is given that
// this software will work like expected.
// This product is not authorized for use as critical component in life support systems
// wihout the express written approval of ARW Elektronik Germany.
//
// Please announce changes and hints to ARW Elektronik
//
// what							who    when
// first steps						AR     10.10.98
//

#define ESCAPE    27
#define BACKSPACE '\b'
#define BLANK     ' '
#define RETURN    '\r'
#define TAB       9

#define MAXBUFSIZE 255     // maximale groesse des edit-buffers

extern void ts_init(void);
extern void ts_deinit(void);
extern int  ts_kbhit(void);
extern void ts_leer_les(void);
extern char ts_getch(void);
extern char ts_getche(void);
extern int  ts_edit_field(int x_pos, int y_pos, void *buffer);

#define __TASTATUR_H__
#endif