#ifndef __CALLS_H__
//-------------------------------------------------------------------------
//
// pcibios support functions - c prototypes for calls realized in assembler
// (c) 1999 ARW Elektronik
//
// this source code is published under GPL (Open Source). You can use, redistrubute and
// modify it unless this header  is  not modified or deleted. No warranty is given that
// this software will work like expected.
// This product is not authorized for use as critical component in life support systems
// wihout the express written approval of ARW Elektronik Germany.
//
// Please announce changes and hints to ARW Elektronik
//
// what							who    when
// first steps						AR     01.11.1997
//
#include <xregs.h>

extern void          pcibios(XREGS *in, XREGS *out);

extern unsigned long readlong(unsigned long far *adresse);

extern void          writelong(unsigned long far *adresse,
				  unsigned long wert);

extern void          movelong(unsigned long far *nach,
				 unsigned long far *von,
				     unsigned long anzahl);

extern void          moveword(unsigned int far *nach,
				 unsigned int far *von,
				     unsigned long anzahl);

extern void          movebyte(unsigned char far *nach,
				 unsigned char far *von,
				     unsigned long anzahl);

#define __CALLS_H__
#endif