//-------------------------------------------------------------------------
//
// 1st submenu of a test program for the PCIVME interface of ARW Elektronik
// (c) 1999 ARW Elektronik
//
// this source code is published under GPL (Open Source). You can use, redistrubute and 
// modify it unless this header  is  not modified or deleted. No warranty is given that 
// this software will work like expected.
// This product is not authorized for use as critical component in life support systems
// wihout the express written approval of ARW Elektronik Germany.
//
// Please announce changes and hints to ARW Elektronik
// 
// what							who    when
// first steps						AR     22.03.99
//

//-------------------------------------------------------------------------
// INCLUDES
//
#include <stdio.h>
#include <menu.h>
#include <pcibios.h>
#include <pcicheck.h>

//-------------------------------------------------------------------------
// DEFINES
//

//-------------------------------------------------------------------------
// TYPDEFS
//

//-------------------------------------------------------------------------
// EXTERNALS
//
extern PCIDEV *selected_device;     // zeigt auf ein device

//-------------------------------------------------------------------------
// GLOBALS
//

//-------------------------------------------------------------------------
// LOCALS
//

//-------------------------------------------------------------------------
// FUNCTIONS
//
static void dummy(void)
{
}

static int action_leave(void)
{
  return 1;
}

static void print_space(int num)
{
  if (selected_device->pciadr.loc[num - 1].io_space)
    printf("IO:  ");
  else
    printf("MEM: ");

  printf("0x%08lx..0x%08lx",
    selected_device->pciadr.loc[num - 1].physical_address,
      selected_device->pciadr.loc[num - 1].physical_address +
        selected_device->pciadr.loc[num - 1].physical_range);
}

static void print_space_1(void)
{
  print_space(1);
}

static void print_space_2(void)
{
  print_space(2);
}

static void print_space_3(void)
{
  print_space(3);
}

static void print_space_4(void)
{
  print_space(4);
}

static void print_space_5(void)
{
  print_space(5);
}

static void print_space_6(void)
{
  print_space(6);
}

// die menudeklaration -------------------------------------------------------
MN_MENU_ENTRY menu_1[] = {{'q', "Leave menu", NULL, action_leave},
			  {-1, "PCI memory configuration registers", print_space_1, NULL},
			  {-1, "PCI io configuration registers", print_space_2, NULL},
			  {-1, "VME interface window", print_space_3, NULL},
			  {-1, "Not used address space", print_space_4, NULL},
			  {-1, "PLX9050 Bug Fix memory", print_space_5, NULL},
			  {-1, "PLX9050 Bug Fix IO", print_space_6, NULL},
			  { 0 , NULL, NULL, NULL}};

int menu_1_entry(void)
{
  return 0;
}