#ifndef __PCIVME_IO_H__
#define __PCIVME_IO_H__
//-------------------------------------------------------------------------
// WINNT driver for PCIVME interface from ARW Elektronik, Germany ---------
// the ioctl functions header file
//
// (c) 1999-2002 ARW Elektronik
//
// this source code is published under GPL (Open Source). You can use, redistrubute and 
// modify it unless this header   is not modified or deleted. No warranty is given that 
// this software will work like expected.
// This product is not authorized for use as critical component in life support systems
// wihout the express written approval of ARW Elektronik Germany.
//
// Please announce changes and hints to ARW Elektronik
// ntddk.h must included first!
//
// $Log: pcivme_io.h,v $
// Revision 1.3  2002/10/27 16:17:48  klaus
// Typing bug fixed caused at log addition
//
// Revision 1.2  2002/10/27 16:11:02  klaus
// Added CVS log into header
//
// what                                            who          when
// started                                         AR           03.07.99
// changed resource allocation caused by WIN2000   AR           08.06.2002
//


//------------------------------------------------------------------------
// FUNCTIONS + EXTERNALS
//
NTSTATUS (*ioctl[])(PDEVICE_OBJECT device_Obj, PIRP irp, PIO_STACK_LOCATION IrpStack);
void fMyDefferedRoutine(PKDPC Dpc, PVOID pvDevice_object, PVOID pvPciada, PVOID Nothing);
void CancelRequest(PDEVICE_OBJECT device_Obj, PIRP Irp);
NTSTATUS removeQueueFromList(PFILE_OBJ pFile_obj, PCIADA *pciada);

void InsertIRPtoQueue(PDEVICE_OBJECT device_Obj, PIRP Irp);
PIRP RemoveIRPfromQueue(PDEVICE_OBJECT device_Obj, FILE_OBJ *pFile_obj);
PIRP RemoveIRPfromQueueByIrp(PDEVICE_OBJECT device_Obj, PIRP pIrpIn);


#endif // __PCIVME_IO_H__
