#ifndef __PCIVMER_H__

//-------------------------------------------------------------------------
// WIN95-driver for the pcivme interface of ARW Elektronik ----------------
// all about registry                                          
// (c) 1999 ARW Elektronik
//
// this source code is published under GPL (Open Source). You can use, redistrubute and 
// modify it unless this header   is not modified or deleted. No warranty is given that 
// this software will work like expected.
// This product is not authorized for use as critical component in life support systems
// wihout the express written approval of ARW Elektronik Germany.
//
// Please announce changes and hints to ARW Elektronik
//
// what                                            who          when
// herausgezogen aus pcivmec.c                     AR           27.06.98
//

#include <regstr.h>
#include "vpcivmed.h"

//-------------------------------------------------------------------------
// FUNKTIONEN
//
void  init_static_status(VPCIVMED_STATIC_STATUS cpIfc[], int maxInterfaces);
void  init_VMEMM_array(WORD wVMEMM[]);

DWORD GetCMInfo(char *name, VPCIVMED_STATIC_STATUS *pIfc);
DWORD ScanRegistry(char *KeyName, VPCIVMED_STATIC_STATUS ifc[], int *NumIFC);
DWORD VerifyHardware(WORD wVMEMM[], VPCIVMED_STATIC_STATUS cpIfc[], int iNumIfc);
DWORD MakeLinearAddresses(VPCIVMED_STATIC_STATUS cpIfc[], int maxInterfaces);

WORD checkInterfaces(WORD wVMEMM[], DWORD dwIndex);

#define __PCIVMER_H__
#endif

//---------------------------- ENDE --------------------------------------

