//-------------------------------------------------------------------------
// helping functions all around the PCIVME interface of ARW Elektronik ----
// 
// (c) 1999 ARW Elektronik
//
// this source code is published under GPL (Open Source). You can use, redistrubute and 
// modify it unless this header   is not modified or deleted. No warranty is given that 
// this software will work like expected.
// This product is not authorized for use as critical component in life support systems
// wihout the express written approval of ARW Elektronik Germany.
//
// Please announce changes and hints to ARW Elektronik
//
// what                                            who          when
// first steps                                     AR           26.01.98
//

#ifndef __PCIVMEX_H__

#include <basedef.h>
#include "vpcivmed.h"

BOOL InitInterface(const VPCIVMED_INIT_COMMAND *psInitTable,
                                                PVOID pvLcr, PVOID pvIfr);
BOOL DeInitInterface(const VPCIVMED_INIT_COMMAND *psDeInitTable,
                                                PVOID pvLcr, PVOID pvIfr);

DWORD get_dynamic_status(VPCIVMED_STATIC_STATUS *psPCIss,
                          VPCIVMED_STANDARD_COMMAND *psSc, 
                            VPCIVMED_DYNAMIC_STATUS *pPCIds, DWORD *pdwLen);
                           
DWORD get_static_status(VPCIVMED_STATIC_STATUS *psPCIssSrc,
                         VPCIVMED_STANDARD_COMMAND *psSc, 
                            VPCIVMED_STATIC_STATUS *pPCIssDest, DWORD *pdwLen);
                           
DWORD get_PCIADA_status(VPCIVMED_STATIC_STATUS sVss[],
                          int iNumIfc, WORD wDriverVersion,
                                 VPCIVMED_PCIADA_STATUS *psVps, DWORD *pdwLen);

DWORD access_vic68a(VPCIVMED_STATIC_STATUS *psPCIss,
                          VPCIVMED_VIC68A_ACTION *psIn,
                               VPCIVMED_VIC68A_ACTION *psOut, DWORD *pdwLen);

DWORD make_tas(VPCIVMED_STATIC_STATUS *psPCIss,
                          VPCIVMED_TAS_STRUCT *psIn,
                               VPCIVMED_TAS_STRUCT *psOut, DWORD *pdwLen);
                               
DWORD make_reset(VPCIVMED_STATIC_STATUS *psPCIss,
                          VPCIVMED_RESET_COMMAND *psIn,
                               VPCIVMED_RESET_RESULT *psOut, DWORD *pdwLen);
#define __PCIVMEX_H__
#endif


