#ifndef ARWPCI_H
#define ARWPCI_H
 
#include <linux/pci.h>
#include <linux/bios32.h>

typedef struct _PCIConfigHeader {
/* start of PCI Configuration register */
 unsigned short device_id, vendor_id;
 unsigned short status, command;
 unsigned short class_code;
 unsigned char rev_id;
 unsigned int unknown1; 
 unsigned int base_address[6]; 
 unsigned int CBSIS;
 unsigned short subsystem_id, subsystem_vendor_id; 
/* end of PCI Configuration register used here */
 unsigned char busnr, devnr;
 unsigned char irq;
 int index;
} PCIConfigHeader;

PCIConfigHeader *GetPCIConfigHeader(short, short, unsigned short);

#endif
