#!/usr/bin/ksh
#
# $Id: version.sh,v 1.1 1999/11/11 13:59:19 mathes Exp $

ARWVME_H_VERSION=$(cat arwvme.h | grep Revision: | awk '{ print $3 }' | \
                  awk -F '.' '{ print ($1*256 + $2) }')
ARWVME_C_VERSION=$(cat arwvme.c | grep Revision: | awk '{ print $3 }' | \
                  awk -F '.' '{ print ($1*256 + $2) }')

#echo "ARWVME_H_VERSION: $ARWVME_H_VERSION"
#echo "ARWVME_C_VERSION: $ARWVME_C_VERSION"

echo -n "#define ARWVME_DRIVER_VERSION  " > arwvme_version.h
echo "((($ARWVME_H_VERSION)<<16) | ($ARWVME_C_VERSION))" >> arwvme_version.h
